/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JDialog.java to edit this template
 */
package vista;

import controlador.DAO.AdaptadorDAOCola;
import controlador.DAO.AdaptadorDAOReclamo;
import controlador.ed.cola.Cola;
import controlador.ed.lista.exception.PosicionException;
import controlador.ed.lista.exception.TopeException;
import controlador.ed.lista.exception.VacioException;
import java.io.IOException;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import modelo.Historial;
import modelo.Reclamo;
import org.hibernate.service.jta.platform.internal.JOTMJtaPlatform;

/**
 *
 * @author alejandro
 */
public class FrmReclamos extends javax.swing.JDialog {

    private AdaptadorDAOReclamo<Reclamo> daoCola = new AdaptadorDAOReclamo(Cola.class);
    private Reclamo reclamo = new Reclamo();

    /**
     * Creates new form FrmReclamos
     */
    public FrmReclamos(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        txtAreaReclamo = new javax.swing.JTextArea();
        jToggleButton1 = new javax.swing.JToggleButton();
        btnVolver = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        txtAreaReclamo.setColumns(20);
        txtAreaReclamo.setRows(5);
        jScrollPane1.setViewportView(txtAreaReclamo);

        jToggleButton1.setText("Enviar");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });

        btnVolver.setBackground(new java.awt.Color(255, 153, 153));
        btnVolver.setText("Volver");
        btnVolver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnVolverActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 388, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(74, 74, 74)
                .addComponent(jToggleButton1)
                .addGap(85, 85, 85)
                .addComponent(btnVolver)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 236, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jToggleButton1)
                    .addComponent(btnVolver))
                .addContainerGap(16, Short.MAX_VALUE))
        );

        setSize(new java.awt.Dimension(410, 330));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        try {
            guardarReclamo();
        } catch (VacioException ex) {
            Logger.getLogger(FrmReclamos.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PosicionException ex) {
            Logger.getLogger(FrmReclamos.class.getName()).log(Level.SEVERE, null, ex);
        } catch (TopeException ex) {
            Logger.getLogger(FrmReclamos.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void btnVolverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnVolverActionPerformed
        // TODO add your handling code here:
        btnVolver.setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_btnVolverActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrmReclamos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrmReclamos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrmReclamos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrmReclamos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                FrmReclamos dialog = new FrmReclamos(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnVolver;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JTextArea txtAreaReclamo;
    // End of variables declaration//GEN-END:variables

    private void guardarReclamo() throws VacioException, PosicionException, TopeException {
        Cola<Reclamo> cola = (Cola<Reclamo>) daoCola.listar();
        try {
            if (cola.getCola().isFull()) {
                borrarPeticiones();
                JOptionPane.showMessageDialog(null, "Lista de peticiones llenas, intente denuevo mas tarde");
            }
            else{
                Reclamo nuevoReclamo = new Reclamo();
                nuevoReclamo.setReclamo(txtAreaReclamo.getText().toString());
                nuevoReclamo.setDate(new Date());
                cola.queue(nuevoReclamo);
                daoCola.guardarCola(cola);
                JOptionPane.showMessageDialog(null, "Reclamo registrado");
            }
        } catch (TopeException | IOException e) {
            System.err.println(e.getMessage());
            JOptionPane.showMessageDialog(null, "Lista de peticiones llenas, intente denuevo mas tarde");
        }

    }

    private void borrarPeticiones() throws VacioException, PosicionException, TopeException, IOException {
        Cola<Reclamo> cola = (Cola<Reclamo>) daoCola.listar();
        Cola<Reclamo> colaNueva = new Cola<>(1000);

        while (!cola.getCola().isEmpty()) {
            Reclamo r = cola.dequeue();
            Date fechaActual = new Date();
            Date fechaReclamo = r.getDate();
            long diferenciaMillis = fechaActual.getTime() - fechaReclamo.getTime();
            long unaHoraEnMillis = 3600;

            if (diferenciaMillis <= unaHoraEnMillis) {
                colaNueva.queue(r);
            }
        }

        daoCola.guardarCola(colaNueva);
    }
}
